{--------------------------------------------------------}
{
{    Programa de impressao do DOSVOX
{
{    Variaveis globais
{
{    Autor: Jose' Antonio Borges
{
{    Em marco/1996 - julho/2000
{
{--------------------------------------------------------}

unit impvars;
interface
uses DVcrt, DVWin, windows;

const
    versao = '2.7';
    debug = true;

    NORMAL = 0;
    NEGRITO = 1;
    ITALICO = 2;
    SUBLINHADO = 4;
    SUPERESCRITO = 8;
    SUBESCRITO = 16;
    RODAPE = 32;

    MAIUSCULAS: set of char = ['A'..'Z', #$c0..#$df];   { ANSI apenas }
    MINUSCULAS: set of char = ['a'..'z', #$e0..#$ff];

    VOGAIS     = ['A', 'E', 'I', 'O', 'U', 'a', 'e', 'i', 'o', 'u',
                  {aeiou agudos}
                  '', '', '', '', '', '', '', '', '', '',
                  {aeo circunflexos}
                  '','','','','','',
                  {ao til}
                  '','','','',
                  {a grave}
                  '',''];

    CONSOANTES = ['B', 'C', 'D', 'F', 'G', 'H', 'J', 'L', 'M',
                  'N', 'P', 'Q', 'R', 'S', 'T', 'V', 'X', 'Z',
                  'b', 'c', 'd', 'f', 'g',{'h',}'j', 'l', 'm',
                  'n', 'p', 'q', 'r', 's', 't', 'v', 'x', 'z',
                  '', '' ];

var
    nomeEntra, nomeSai: string;       { nomes dos arquivos }
    arqEntra  :  file;                { arquivo de entrada }
    arqDebug: text;                   { arquivo de saiva em texto puro }
    acabouArq: boolean;               { arquivo acabou de ser lido }

    primLinha, primCol: integer;      { primeira linha e coluna a imprimir }
    ultLinha, ultCol: integer;        { ltima linha e coluna a imprimir }
    primColCabec: integer;            { primeira coluna do cabealho }
    ultColCabec: integer;             { ltima coluna do cabealho }

    pagInicial, pagFinal: integer;    { pgina inicial e final a imprimir }
    numInicial: integer;              { nmero a imprimir na primeira pgina }
    espacejamento: integer;           { espacejamento (1, 2, 3) }
    autoFormata, alinhaDireita, separaSilabas: boolean;

    ncopias: integer;                 { nmero de cpias }
    titulando: boolean;               { foi especificado ttulo }
    titulo: string;                   { ttulo da pgina atual }

    DCimpr: hDC;                      { contexto do dispositivo da impressora}
    fonte: array [0..63] of hFont;    { fontes alocados at o momento }
    tamFonte: integer;                { tamanho do fonte em "pontos de fonte" }
    xfonte, yfonte: integer;          { tamanho do fonte normal em pixels }
    tamFonteRod: integer;             { tamanho do fonte em "pontos de fonte" }
    xfonteRod, yfonteRod: integer;    { tamanho do fonte rodap em pixels }

    ximpr, yimpr: longint;            { posio atual de impresso }
    limyimpr: longint;                { limite inferior para impresso }
    x0pag, y0pag: longint;            { deslocamentos iniciais na pgina }
    deltay: longint;                  { intervalo entre linhas }
    deltayRod: longint;               { intervalo entre linhas no rodap }
    deslocVert: integer;              { deslocamento quando subescrito ou superescrito }

    copiaAtual: integer;              { Nmero da cpia atual }
    desistiu: boolean;                { Usurio apertou ESC durante o processamento }

    numPag: integer;                  { nmero da pgina atual }
    nlinPag: integer;                 { nmero de linhas impressas na pgina }
    sobraLinha: string;               { sobra para prxima linha durante a formatao }
    brancosMargem: string;            { brancos da margem esquerda }

{--------------------------------------------------------}
{               variveis do formatador
{--------------------------------------------------------}

const
    MAXRODAPE = 50;

type
    LETRALIDA = (ESPACO, CARACTERE, ABRECOMANDO, FIMLINHA, FIMARQ);
    COISALIDA = (BRANCOS, LETRAS, COMANDO, FIM);

type
    TAtribLinha = array [0..255] of word;

var
    jaLido: boolean;                     { deve reler ltima letra }
    ultLetra: char;                      { ltima letra lida }
    ultCodigo: LETRALIDA;                { ltimo cdigo processado }
    trecho: string;                      { trecho atual }
    tipoTrecho: COISALIDA;               { tipo deste trecho }

    linha, coluna: integer;              { nmero da linha e coluna atual }
    linhaSaida, resto: string;           { linha processada e a processar }
    atribSaida, atribResto: TAtribLinha; { atributos armazenados }
    tipoLetra: word;                     { tipo da letra atual }
    ultAtrib: word;                      { ltimo atributo }

    processando: boolean;                { est formatando ainda }
    ultimoFoiNL: boolean;                { houve um salto de linha antes desta }
    linhaVazia: boolean;                 { linha de sada est vazia (embora com brancos iniciais) }
    centrando : boolean;                 { est centrando }
    impressaoPermitida: boolean;         { no est pulando pginas iniciais }

    emRodape: boolean;
    salvaPrimCol, salvaUltCol: integer;  { salva primeira e ltima coluna durante rodap }
    salvaTipo: integer;                  { salva tipo da letra durante rodap }

    primRodape, nlRodape: integer;       { filas de linhas e atributos do rodap }
    txtRodape: array [0..MAXRODAPE-1] of ^string;
    atribRodape: array [0..MAXRODAPE-1] of ^TAtribLinha;

implementation
end.
